
#ifndef FCP_H_
#define FCP_H_

#include <stdbool.h>

typedef void (*CS_REG_CALLBACK)(void *arg, uint32_t reg, uint32_t val);

// Prototypes
extern int cs_init(uint32_t camera_ip, unsigned short camera_port);
extern void cs_destroy();

extern uint32_t cs_get_reg_l(uint32_t reg, uint32_t *val);
extern uint32_t cs_set_reg_l(uint32_t reg, uint32_t val, int *istat);
extern int cs_read_array(int array_id, void *data_ptr, uint16_t data_len);
extern int cs_write_array(int array_id, const void *data_ptr, uint16_t data_len);

extern void cs_register_callback(CS_REG_CALLBACK new_callback, void *arg);

#endif
