/*!
 * @file fi_liveview_protocol.h
 * @brief Header file for the external interface for the fcp_protocol.cpp.
 *
 * Copyright 2015 (c) Fastec Imaging as an unpublished work.
 * All Rights Reserved.
 *
 * The information contained herein is confidential property of
 * Fastec Imaging. The use, copying, transfer or disclosure of such
 * information is prohibited except by express written agreement
 * with Fastec Imaging.
 */
#ifndef FCP_LISTEN_PROTOCOL_H_
#define FCP_LISTEN_PROTOCOL_H_

//--------------------------------------------------------------------
// Includes
//--------------------------------------------------------------------
#include "libwebsockets.h"

class fiWSSFCPListenProtocol
{
public:
    // Web Socket Server FCP Protocol constructor
    // Must provide the
    fiWSSFCPListenProtocol( struct lws_protocols* myProtocolRecPtr );

    // Web Socket Server FCP Protocol destructor
    // cleans up and destructs a web socket server object
    ~fiWSSFCPListenProtocol();

    // provide function to determine if the protocol handler is ready
    // for use -
    bool isReady();

private:
    // will be set to 1 if the object is initialized for protocol handling
    bool IAmInitialized;

    // what is the callback handler function for this handler
    static int	callback_fcp_listener( struct lws *wsi,
                                           enum lws_callback_reasons reason,
                                           void *user, void *p_json_pkg, size_t len );

};

#endif	/* !FCP_LISTEN_PROTOCOL_H_ */
