/*!
 * @file fcp_protocol.h
 * @brief header file for the external interface for the fi-fcp_protocol.cxx
 *
 * Copyright 2015 (c) Fastec Imaging as an unpublished work.
 * All Rights Reserved.
 *
 * The information contained herein is confidential property of
 * Fastec Imaging. The use, copying, transfer or disclosure of such
 * information is prohibited except by express written agreement
 * with Fastec Imaging.
 */
#ifndef FCP_PROTOCOL_H_
#define FCP_PROTOCOL_H_

//--------------------------------------------------------------------
// Includes
//--------------------------------------------------------------------
#include "libwebsockets.h"

class fiWSSFCPProtocol
{
public:
    // Web Socket Server Fastec Control Protocol constructor
    // Must provide the
    fiWSSFCPProtocol( struct lws_protocols* myProtocolRecPtr );

    // Web Socket Server Fastec Control Protocol destructor
    // cleans up and destructs a web socket server object
    ~fiWSSFCPProtocol();

    // provide function to determine if the protocol handler is ready
    // for use -
    bool isReady();

private:
    // will be set to 1 if the object is initialized for protocol handling
    bool IAmInitialized;

    // what is the callback handler function for this handler
    static int	callback_fcp( struct lws *wsi,
                                  enum lws_callback_reasons reason,
                                  void *user, void *p_json_pkg, size_t len );
};

#endif	/* !FCP_PROTOCOL_H_ */
