/*!
 * @file fi_http_protocol.h
 * @brief header file for the external interface for the fi_ftp_protocol.cxx
 *
 * Copyright 2018 (c) Fastec Imaging as an unpublished work.
 * All Rights Reserved.
 *
 * The information contained herein is confidential property of
 * Fastec Imaging. The use, copying, transfer or disclosure of such
 * information is prohibited except by express written agreement
 * with Fastec Imaging.
 */
#ifndef FI_HTTP_PROTOCOL_H_
#define FI_HTTP_PROTOCOL_H_

//--------------------------------------------------------------------
// Includes
//--------------------------------------------------------------------
#include "libwebsockets.h"

class fiHTTPProtocol
{
public:
    // HTTP constructor
    fiHTTPProtocol( struct lws_protocols* myProtocolRecPtr );

    // HTTP destructor
    // cleans up and destructs a web socket server object
    ~fiHTTPProtocol();

    // provide function to determine if the protocol handler is ready
    // for use -
    bool isReady();

private:
    // will be set to 1 if the object is initialized for protocol handling
    bool IAmInitialized;
};

#endif	/* !FI_HTTP_PROTOCOL_H_ */
