/*!
 * @file fi_wss_main.h
 * @brief Fastec Imaging Web Socket Server Main Module
 *
 * Copyright 2016 (c) Fastec Imaging as an unpublished work.
 * All Rights Reserved.
 *
 * The information contained herein is confidential property of
 * Fastec Imaging. The use, copying, transfer or disclosure of such
 * information is prohibited except by express written agreement
 * with Fastec Imaging.
 */
#ifndef FI_WSS_MAIN_H_
#define FI_WSS_MAIN_H_

//--------------------------------------------------------------------
// Includes
//--------------------------------------------------------------------
#include "fi_cs.h"

//--------------------------------------------------------------------
// Constant, Typedefs and Macros
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// Data Structures and Definitions
//--------------------------------------------------------------------

// ///////////////////////////////////////////////////////////////////
//--------------------------------------------------------------------
// External Interfaces
//--------------------------------------------------------------------
// ///////////////////////////////////////////////////////////////////

// Right now the Web Socket Server only maintains a single connection
// to a Camera Server.  In the future this may change and multiple
// Camera Server Connections may be needed for a single WSS - probably
// not likely since the WSS runs on the Camera running the CS but who knows!
extern fiCameraServerIO* fiGetCS();

#endif	/* !FI_WSS_MAIN_H_ */
