/*!
 * @file status_update.h
 * @brief Header file for the external interface for the status_update.cxx
 *
 * Copyright 2010-2016 (c) Fastec Imaging as an unpublished work.
 * All Rights Reserved.
 *
 * The information contained herein is confidential property of
 * Fastec Imaging. The use, copying, transfer or disclosure of such
 * information is prohibited except by express written agreement
 * with Fastec Imaging.
 */

#ifndef STATUS_UPDATE_H
#define STATUS_UPDATE_H

//--------------------------------------------------------------------
// Includes
//--------------------------------------------------------------------
#include <stdio.h>
#include <stdint.h>
#include <string>

#include <errno.h>
#include <pthread.h>

#include "fcp.h"

//--------------------------------------------------------------------
// Forward Class Declarations
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// Constant Declarations or Enumerations Used in class
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// Class: StatusUpdate
//--------------------------------------------------------------------

class StatusUpdate
{
public:
    StatusUpdate();
    ~StatusUpdate();

private:
    static void *entry(void *self)
    {
        static_cast<StatusUpdate *>(self)->run((void *)NULL);
        return NULL;
    }
    static void su_callback( void* arg, uint32_t reg, uint32_t val )
    {
        static_cast<StatusUpdate *>(arg)->cs_notify( reg, val );
    }

    void cs_notify( uint32_t reg_addr, uint32_t reg_value );
    void record_poll( void );
    void run( void *t );

    pthread_t 		thread;
    pthread_mutex_t	lock;
    pthread_cond_t	notify_ready;

    int	update_state;
};

#endif // STATUS_UPDATE_H
