/*
 * fi_wss_session.cxx
 *
 *  Created on: Jan 27, 2016
 *      Author: eric
 */

#include <string.h>
#include <errno.h>

#include "libwebsockets.h"

#include "fi_wss_session.h"

WssSession::WssSession(WssProtocol* p, struct lws* l) :
    wsi(l),
    proto(p)
{
    lwsl_debug("WssSession(0x%08X)/%d",
               (void*)this,
               lws_get_socket_fd(wsi) );
}

WssSession::~WssSession()
{
    lwsl_debug("~WssSession(0x%08X)/%d",
               (void*)this,
               lws_get_socket_fd(wsi) );
}

WssProtocol* WssSession::protocol()
{
    return proto;
}

struct lws* WssSession::get_lws()
{
    return wsi;
}

void WssSession::tx_flush()
{
    int sock = lws_get_socket_fd( wsi );
    if ( (sock < 0)  ||  (shutdown(sock, SHUT_RDWR) != 0) )
        lwsl_err("Could not shutdown connection: %s\n", strerror(errno));
}

